diff --git a/CMakeLists.txt b/CMakeLists.txt
index df10282a4..9dc70cc8a 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -152,6 +152,23 @@ endif()
 
 set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)
 
+# Certain toolchains do not set archiver & ranlib tool variables per-language
+if(NOT "" STREQUAL "${CMAKE_AR}")
+  message(STATUS "using ar; ${CMAKE_AR}")
+  set(CMAKE_C_COMPILER_AR "${CMAKE_AR}")
+  set(CMAKE_CXX_COMPILER_AR "${CMAKE_AR}")
+  unset(CMAKE_C_COMPILER_AR-NOTFOUND)
+  unset(CMAKE_CXX_COMPILER_AR-NOTFOUND)
+endif()
+
+if(NOT "" STREQUAL "${CMAKE_RANLIB}")
+  message(STATUS "using ranlib; ${CMAKE_RANLIB}")
+  set(CMAKE_C_COMPILER_RANLIB "${CMAKE_RANLIB}")
+  set(CMAKE_CXX_COMPILER_RANLIB "${CMAKE_RANLIB}")
+  unset(CMAKE_C_COMPILER_RANLIB-NOTFOUND)
+  unset(CMAKE_CXX_COMPILER_RANLIB-NOTFOUND)
+endif()
+
 if(IPO)
   include(CheckIPOSupported)
   check_ipo_supported(RESULT ipo_supported OUTPUT ipo_output)
@@ -2787,7 +2804,6 @@ if(SERVER)
 
     ${LIBS}
   )
-
   add_library(server-without-main OBJECT
       ${DEPS}
       ${SERVER_SRC}
@@ -3021,7 +3037,7 @@ if(GTEST_FOUND OR DOWNLOAD_GTEST)
   add_executable(${TARGET_TESTRUNNER} EXCLUDE_FROM_ALL
     ${TESTS}
     ${TESTS_EXTRA}
-    $<TARGET_OBJECTS:server-without-main>
+    $<IF:$<BOOL:${SERVER}>,$<TARGET_OBJECTS:server-without-main>,>
     $<TARGET_OBJECTS:engine-gfx>
     $<TARGET_OBJECTS:engine-shared>
     $<TARGET_OBJECTS:game-shared>
